unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

Type TArray = array of array of char;

Type
    PCesta = ^TCesta;
    TCesta = record
       vektor: string;
       dalsi: PCesta;
     end;

type TAuto = class
  mapa: TArray;
  width, height: Integer;
  startX: Integer;
  startY: Integer;

  nalezeno: boolean; //ano, nelzl jsem cestu

  kotva: PCesta;
  prohledavani: array[0..255] of PCesta; //abych urychlil vyhledavani zda uz jsem provedl jstejnou operaci
  aktualni: PCesta; //aktualni pridavany prvek

  constructor create;

  function loadMap(fileName: string): Boolean;
  procedure setArrayLength; // width and heigh pole
  function zobraz(image: TImage): boolean; // zobraz obrazek

  procedure getSouradniceByVektor(vektory: String; var posX, posY: Integer);// z vektory zapsanem napr "abcd" -> dostanu skutecny bod, zacatek bran od startovni pozice
  procedure getVektorByChar(ch: Char; var x, y: Integer);

  procedure krok(cesta: String);
  procedure pridej(cesta: String);
  function mohuPridat(cesta: String): Boolean;

  procedure zobrazVektor(vektor: String; image: TImage);
  function getFromMapa(x, y: Integer): Char;
  procedure nalezniCestu;
  procedure vypis;
  //  procedure hledejCestu;

end;

implementation
uses unit1;

procedure TAuto.vypis;
var pom: PCesta;
begin
  pom := kotva;
  form1.ListBox1.Clear;
  while pom <> nil do
  begin
    form1.ListBox1.Items.Add(pom^.vektor);
    pom := pom^.dalsi;
  end;

end;

function TAuto.getFromMapa(x, y: Integer): Char;
begin
  Result := 'X';

  if (x >= width) or (x < 0) then
    Exit;

  if (y >= height) or (y < 0) then
    Exit;

  Result := mapa[x,y];
end;

procedure TAuto.nalezniCestu;
var pom:PCesta;
    cnt: Integer;
begin
  form1.ListBox1.Clear;
  kotva := nil;

  nalezeno := false;

  for cnt := 0 to high(prohledavani) do
    prohledavani[cnt] := nil;

  krok('');
  pom := kotva;
  while pom <> nil do
  begin
    krok(pom^.vektor);

    if nalezeno then
     exit;

    pom := pom^.dalsi;
  end;

end;

procedure TAuto.zobrazVektor(vektor: String; image: TImage);
var cnt: Integer;
    x, y: Integer;
    sirka, vyska: Integer;
    
begin
  sirka := round(image.width / width);

  vyska := round(image.Height / height);

  if sirka > vyska then
   sirka := vyska;

  image.Canvas.Pen.Style := psSolid;
  image.Canvas.brush.Color := clSkyBlue;

  for cnt := 1 to length(vektor) do
  begin
    getSouradniceByVektor(copy(vektor,1, cnt ), x ,y);
    image.Canvas.Rectangle(x * sirka, y * sirka, x * sirka + sirka, y * sirka + sirka);
  end;

end;

constructor TAuto.create;
var cnt: Integer;
begin
  kotva := nil;
  aktualni := nil;

  for cnt := 0 to high(prohledavani) do
   prohledavani[cnt] := nil;
end;

procedure TAuto.krok(cesta: String);
var ch: char;
    pom: String;
    x, y: Integer;
    cnt: Integer;

    pomx, pomy: Integer;
begin
  pom := cesta;
  for ch := 'a' to 'i' do
  begin

    if ch = 'd' then continue;
    getSouradniceByVektor(pom + ch, x, y);

    if getFromMapa(x, y) = 'X' then
    begin
      if length(pom)> 1 then
        if pom[length(pom)-1] <> 'x' then
          if mohuPridat(pom + 'x') then
          begin
           pridej(pom + 'x');
         end;
    end;

    if getFromMapa(x, y) <>'X' then
    begin
      if getFromMapa(x, y) = 'C' then
      begin
        ShowMessage('Cesta nalezena');
        pom := pom + ch;
        zobraz(Form1.Image1);
        zobrazVektor(pom, Form1.Image1);
        for cnt := 1 to length(pom) do
        begin
          getVektorByChar(pom[cnt], pomx, pomy);
          form1.ListBox1.Items.Add(format('%d,%d',[pomx, pomy]));
        end;
        nalezeno := true;
        exit;
      end;

      if mohuPridat(pom + ch) then
      begin
        pridej(pom + ch);
      end;
    end;
  end;
end;



procedure TAuto.pridej(cesta: String);
var x, y: Integer;
    pom: PCesta;
    pom1: PCesta;
begin
  getSouradniceByVektor(cesta, x ,y);
  new(pom);
  pom^.vektor := cesta;
  pom^.dalsi := nil;

  if aktualni <> nil then
    aktualni^.dalsi := pom;

  aktualni := pom;

  if  kotva = nil then
   kotva := aktualni;

  new(pom1);
  pom1^.vektor := cesta;
  pom1.dalsi := prohledavani[x];
  prohledavani[x] := pom1;


  ///////////
  if Form1.CheckBox1.Checked then
  begin
    zobraz(form1.Image1);
    zobrazVektor(cesta, form1.Image1);
    //vypis;
    Form1.Image1.Repaint;
    Application.ProcessMessages;
  //Sleep(20);
  end;
end;

function TAuto.mohuPridat(cesta: String): Boolean;
var pom: PCesta;
    x,y: Integer;
    px, py: Integer;
begin
  Result := false;
  
  getSouradniceByVektor(cesta, x, y);

  Result := false;
  pom := prohledavani[x];

  while pom <> nil do
  begin
    //ShowMessage(pom^.vektor);
    getSouradniceByVektor(pom^.vektor, px, py);

    {if pom^.vektor = cesta then
     Exit;}
    if (px = x) and (py =y) then
    begin
      if cesta[length(cesta)] <> 'x' then
      exit;
    end;
    pom := pom^.dalsi;
  end;

  Result := true;

end;

procedure TAuto.getVektorByChar(ch: Char; var x, y: Integer);
//ukladam vektor ve tvaru "abcd" - kazde pismenko znamena jeden vektors
begin
  x := 0;
  y := 0;

  case ch of
  'a': begin
         x := -1;
         y := -1;
       end;

  'b': begin
         x := -1;
         y := 0;
       end;
   'c': begin
         x := 0;
         y := -1;
       end;
   'd': begin
         x := 0;
         y := 0;
       end;
   'e': begin
         x := 0;
         y := 1;
       end;
   'f': begin
         x := 1;
         y := 0;
       end;

   'g': begin
         x := 1;
         y := 1;
       end;

    'h': begin
         x := -1;
         y := 1;
       end;

    'i': begin
         x := 1;
         y := -1;
       end;


  end;
end;

procedure TAuto.getSouradniceByVektor(vektory: String;var posX, posY: Integer);
var x, y: Integer;
    rychlostX, rychlostY: Integer;
    cnt: Integer;
begin
   posX := startX;
   posY := startY;

   rychlostX := 0;
   rychlostY := 0;

   for cnt := 1 to length(vektory) do
   begin

     if vektory[cnt] = 'x' then
     begin
       rychlostX := 0;
       rychlostY := 0;
     end;

     getVektorByChar(vektory[cnt], x, y);

     rychlostX := rychlostX + x;
     rychlosty := rychlostY + y;

     posX := posX + rychlostX;
     posY := posY + rychlostY;
     //showmessage(format('%d %d', [posx, posy]));
   end;

end;

function TAuto.zobraz(image: TImage): boolean;
var x, y: Integer;
    sirka: Integer;
    vyska: Integer;
begin
  Result := false;

  sirka := round(image.width / width);

  vyska := round(image.Height / height);

  if sirka > vyska then
   sirka := vyska;

  image.Canvas.Pen.Style := psClear;
  image.Canvas.Brush.Color := clBlack;
  image.Canvas.Rectangle(-1, -1, image.Width +1, image.Height +1);

  for x := 0 to width - 1 do
    for y := 0 to height - 1 do
    begin
      case mapa[x, y] of
        'X': image.Canvas.Brush.Color := clblack;
        ':': image.Canvas.Brush.Color := clMoneyGreen;
        '.': image.Canvas.Brush.Color := clGreen;
        'C': image.Canvas.Brush.Color := clYellow;
        'S': image.Canvas.Brush.Color := clRed;
      end;
      image.Canvas.Rectangle(x * sirka, y * sirka, x * sirka + sirka+1, y * sirka + sirka+1);

      if mapa[x, y] = 'S' then
      begin
        startX := x;
        startY := y;
      end;


    end;
    Result := true;
end;

procedure TAuto.setArrayLength;
var cnt: Integer;
begin
  setLength(mapa, width);

  for cnt := 0 to High(mapa) do
    SetLength(mapa[cnt], height);

end;

function TAuto.loadMap(fileName: string): Boolean;
var list: TStringList;
    x, y: Integer;
    znamenko: Char;
    cil: Integer;
begin
  Result := false;

  startX := -1;
  starty := -1;
  cil := 0;

  if not FileExists(fileName) then
    exit;

  list := TStringList.Create;

  try
    list.LoadFromFile(fileName);

    self.width := length(list[0]);
    self.height := list.Count;

    setArrayLength;

    for y := 0 to height - 1 do
      for x := 0 to width - 1 do
      begin

        if (width <> length(list[y]))  then
        begin
          list.Free;
          ShowMessage('chyba');
          Exit;
        end;
        znamenko := uppercase(list[y][x + 1])[1];

        if znamenko = 'S' then
        begin
          startX := x;
          startY := y;
        end;

        if znamenko = 'C' then
          inc(cil);

        mapa[x, y] := znamenko;
      end;

    Result := true;
  finally
    list.Free;
  end;

  if (cil = 0) or (startX = -1) or (startX = -1) then
    Result := false;
end;


end.
